# @author: Karl Lattimer
# quick test of the rendering speed of a treeview cell

import re, gtk, gobject
from time import gmtime, strftime

filterwords = [ "h", 
				"he", 
				"hel", 
				"help", 
				"help ", 
				"help m",
				"help me",
				"help me ",
				"help me h",
				"help me he",
				"help me hel",
				"help me help",
				"help me help ",
				"help me help y",
				"help me help yo",
				"help me help you" ]


search_list = [	"help me help",
				"help me",
				"help me help you",
				"help",
				"help me help",
				"help me",
				"help me help you",
				"help",
				"help me help",
				"help me",
				"help me help you",
				"help",
				"help me help",
				"help me",
				"help me help you",
				"help",
				"help me help",
				"help me",
				"help me help you",
				"help",
				"help me help",
				"help me",
				"help me help you",
				"help",
				"i need help will help me",
				"help me help",
				"help me",
				"help me help you",
				"help",
				"help me help",
				"help me",
				"help me help you",
				"help",
				"help me help",
				"help me",
				"help me help you",
				"help",
				"i need help will help me",
				"help me help",
				"help me",
				"help me help you",
				"help",
				"help me help",
				"help me",
				"help me help you",
				"help",
				"help me help",
				"help me",
				"help me help you",
				"help",
				"i need help will help me",
				"help me help",
				"help me",
				"help me help you",
				"help",
				"help me help",
				"help me",
				"help me help you",
				"help",
				"help me help",
				"help me",
				"help me help you",
				"help",
				"i need help will help me",
				"help me help",
				"help me",
				"help me help you",
				"help",
				"help me help",
				"help me",
				"help me help you",
				"help",
				"help me help",
				"help me",
				"help me help you",
				"help",
				"i need help will help me",
				"help me help",
				"help me",
				"help me help you",
				"help",
				"help me help",
				"help me",
				"help me help you",
				"help",
				"help me help",
				"help me",
				"help me help you",
				"help",
				"i need help will help me",
				"help me help",
				"help me",
				"help me help you",
				"help",
				"help me help",
				"help me",
				"help me help you",
				"help",
				"help me help",
				"help me",
				"help me help you",
				"help",
				"i need help will help me",
				"help me help",
				"help me",
				"help me help you",
				"help",
				"help me help",
				"help me",
				"help me help you",
				"help",
				"help me help",
				"help me",
				"help me help you",
				"help",
				"i need help will help me"
				 ]

STRING, INDEX = range( 2 )

def filterlist ( filter_text ):
	mylist = []
	myreg = re.compile( '.*'+filter_text+'.*', re.I | re.M )
	for index, text in enumerate(search_list):
		if myreg.match( text ):
			#print "match at index %s" % index
			mylist.append( text )
	return mylist

def filtertimer ():
	print "Start filter loop at "+strftime("%H:%M:%S", gmtime())
	for word in filterwords:
		filterlist ( word )
	print "Ended filter loop at "+strftime("%H:%M:%S", gmtime())

class FilterBench:
	def hello(self, widget, data=None):
		print "Hello World"

	def delete_event(self, widget, event, data=None):
		print "delete event occurred"
		return False

	def destroy(self, widget, data=None):
		gtk.main_quit()
	
	def update_model(self):
		self.model = gtk.ListStore( gobject.TYPE_STRING, 
							   		gobject.TYPE_INT )
		myfiltered_list = filterlist(self.entry.get_text())
		#print myfiltered_list
		for index, text in enumerate(myfiltered_list):
			myiter = self.model.append()
			#print text+" %s" % index
			self.model.set( myiter, STRING, text, 
					  		INDEX, index)

	def on_filter_change(self, widget, data=None):
		print "Start filter loop at "+strftime("%H:%M:%S", gmtime())
		self.update_model()
		self.treeview.set_model(self.model)
		print "Ended filter loop at "+strftime("%H:%M:%S", gmtime())

	def __init__(self):
		self.window = gtk.Window(gtk.WINDOW_TOPLEVEL)
		self.window.connect("delete_event", self.delete_event)
		self.window.connect("destroy", self.destroy)
		self.window.set_title("Basic TreeView filter speed test")

		vbox = gtk.VBox(False, 10)

		self.entry = gtk.Entry()
		vbox.pack_start(self.entry, False, False)
		self.entry.connect("changed", self.on_filter_change)

		self.model = gtk.ListStore( gobject.TYPE_STRING, 
							   		gobject.TYPE_INT )

		for index, text in enumerate(search_list):
			myiter = self.model.append()
			self.model.set( myiter, STRING, text, 
					  		INDEX, index)

		self.treeview = gtk.TreeView()

		column = gtk.TreeViewColumn( 'Text', gtk.CellRendererText(), text=STRING )
		column.set_sort_column_id( STRING )
		self.treeview.append_column( column )
		column = gtk.TreeViewColumn( 'index', gtk.CellRendererText(), text=INDEX )
		column.set_sort_column_id( INDEX )
		self.treeview.append_column( column )
		
		self.treeview.set_model(self.model)
		self.treeview.set_search_column( STRING )

		vbox.pack_start(self.treeview, True, True)
		
		self.window.add(vbox)
		self.window.show_all()


if __name__ == "__main__":
	hello_world = FilterBench()
	gtk.main()
	#filtertimer()
