import gtk, gobject, gtk.glade, urllib, os

# Example of a simple gtk downloader with progress bar
# @author: Karl Lattimer <karl@wine-doors.org>

# urllib.urlretrieve callback function
def update_progress( blocks, block_size, total_size ):
    percentage = float ( blocks * block_size ) / total_size
    if percentage > 1:
        percentage = 1

    text_percent = "%s" % int ( percentage * 100 )
    window['progressbar'].set_text( text_percent + " %" )
    window['progressbar'].set_fraction( percentage )
    # Can't use a generator for this as urllib is doing all the
    # work, instead we hack around it
    while gtk.events_pending():
        gtk.main_iteration()

# This doesn't do any error checking there isn't much point in this example
def download( url ):
    urllib.urlretrieve( url, "test.file", update_progress )

# A couple of glade callbacks
class GladeHandlers:
    def on_initiate_clicked ( widget, data=None ):
        url = window['url'].get_text()
        if url != "":
            window['initiate'].set_sensitive( False )
            download( url )
        
    def on_close_clicked ( widget, data=None ):
        gtk.main_quit()

# Bog standard glade window class
class Window:
    def __init__( self, window_name ):
        #os.chdir( os.path.dirname( __file__ ) )
        self.widgets = gtk.glade.XML( 'urllib-downloader.glade', window_name )
        self.widgets.signal_autoconnect( GladeHandlers.__dict__ )
        
    def __getitem__( self, key ):
        return self.widgets.get_widget( key )

if __name__ == "__main__":
    window = Window( 'wn_downloader' )
    gtk.main()