import os, string

# CountInstances
import subprocess
from subprocess import PIPE

# WaitForExit
import select, thread

# WineDoors global instances
from preferences import preferences
from log import log

class Wine:
	def CountInstances( self, process_name="wine" ):
		ps = subprocess.Popen( ["ps", "xwww"], stdout=PIPE )
		gp = subprocess.Popen( ["grep", process_name], stdin=ps.stdout, stdout=PIPE )
		gg = subprocess.Popen( ["grep", "-v", "grep"], stdin=gp.stdout, stdout=PIPE )
		gs = subprocess.Popen( ["grep", "-v", "python"], stdin=gg.stdout, stdout=PIPE )
		wc = subprocess.Popen( ["wc", "-l"], stdin=gs.stdout, stdout=PIPE )
		processes = wc.communicate()[0]
		processes = processes.rstrip()
		processes = int( processes )
		return processes
	
	def CheckDrive( self ):
		log.Debug( "Checking wine drive: " + preferences['wineroot'] )
		
		if os.path.isdir( preferences['wineroot'] + "/wine-doors" ):
			self.drive = True
		else:
			self.drive = False
			
		return self.drive

	def CreateDrive( self ):
		if os.path.isdir( preferences['wineroot'] ):
			log.Log( "Wine drive already exists, cowardly refusing to manage already installed apps" )
		else:
			os.system( "wineprefixcreate --prefix %s > /dev/null 2>&1" % preferences['wineroot'] )
		if not os.path.isdir( preferences['wineroot'] ):
			log.Error( "Failed to create wine drive" )
			return
		if not os.path.exists( preferences['wineroot']+"/wine-doors" ):
			os.mkdir( preferences['wineroot']+"/wine-doors" )
		if not os.path.exists( preferences['wineroot']+"/wine-doors/installer-cache" ):
			os.mkdir( preferences['wineroot']+"/wine-doors/installer-cache" )
		if not os.path.exists( preferences['wineroot']+"/wine-doors/packlists" ):
			os.mkdir( preferences['wineroot']+"/wine-doors/packlists" )
		if not os.path.exists( preferences['wineroot']+"/wine-doors/apppacks" ):
			os.mkdir( preferences['wineroot']+"/wine-doors/apppacks" )
		if not os.path.exists( preferences['wineroot']+"/wine-doors/icons" ):
			os.mkdir( preferences['wineroot']+"/wine-doors/icons" )
		os.system( "winecfg -D" ) #autoconfigure drives
		self.WaitForExit()
		# I owe this honorable code to Mr Jason Tackaberry who without it, it wouldn't have
		# been possible.
		if os.path.isfile( preferences['wineroot']+"/system.reg" ):
			lines = [ line.replace( "Change preferred owner in ~/.wine/system.reg", name )
					  for line in file( preferences['wineroot']+"/system.reg" ) ]
			file( preferences['wineroot']+"/system.reg", "w" ).write( "".join( lines ) )
			lines = [ line.replace( "Change preferred organization in ~/.wine/system.reg", company )
					  for line in file( preferences['wineroot']+"/system.reg" ) ]
			file( preferences['wineroot']+"/system.reg", "w" ).write( "".join( lines ) )
		else:
			log.Error( "System.reg does not exist" )
	
	def WaitForExit( self, timeout=300 ):
		reader, writer = os.pipe()
		def wait_for_wineserver():
			os.system( "wineserver -w" )
			#TODO: We should really close that process and wait on it if necessary
			os.write( writer, "done" )
		thread.start_new_thread( wait_for_wineserver, () )
		readable, dummy, dummy = select.select( ( reader, ), (), (), timeout )
		if readable:
			return True
		else:
			return False
	
	def Kill( self ):
		log.Debug( "Killing wine" )
		for pname in ( "wine", "wine-pthread", "wineserver", "winedbg" ):
			while self.CountInstances( pname ):
				os.system( "/usr/bin/killall -9 %s" % pname )
				log.Debug( "Killing %s" % pname )
		self.Reboot()
	
	def Reboot( self ):
		os.system( "%s wineboot" % preferences['winebinary'] )
		
	def isShellScript( script ):
		if script.endswith( ".sh" ):
			return True
		# Should probably check for "#!/" at the beginning of the file also
		type = os.popen( "file "+script ).read()
		return type.lower().find( "shell script" ) >= 0
	
	def Execute( self, executable ):
		if executable.endswith( ".msi" ):
			run = "msiexec " + executable
		elif self.isShellScript( executeable ):
			run = "/bin/sh " + executable
		else:
			run = preferences['winebinary'] + " " + executable
		  
		retval = os.system( run )
		return retval
		  
wine = Wine()

if __name__ == "__main__":
	wine.CheckDrive()
	if not wine.drive:
		print "Wine Drive does not exist, creating one"
		wine.CreateDrive()

	proc = wine.CountInstances()
	if proc > 0:
	   print "Counted %d wine processes, waiting for exit" % proc
	   wine.WaitForExit()	   